\\ Copyright 2016 Kevin Ryde
\\
\\ This file is free software; you can redistribute it and/or modify it
\\ under the terms of the GNU General Public License as published by the Free
\\ Software Foundation; either version 3, or (at your option) any later
\\ version.
\\
\\ This file is distributed in the hope that it will be useful, but
\\ WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
\\ or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
\\ for more details.
\\
\\ You should have received a copy of the GNU General Public License along
\\ with this file.  If not, see <http://www.gnu.org/licenses/>.

default(recover,0);
default(strictargs,1);
iferr(read("recurrence-guess.gp"),e,read("../recurrence-guess.gp"));

verbose = 1;
test_count = 0;
test_equal_noprint(got,want,name="") =
{
  test_count++;
  \\ print("got  ",got);
  \\ print("want ",got);
  if(got!=want,
     if(name!="",print1(name,": "));
     print("oops\ngot =",got,"\nwant=",want);
     quit(1));
}
test_equal(got,want,name="") =
{
  test_equal_noprint(got,want,name);
  if(verbose,
     if(name=="",print("ok"),print(name,"  ok")));
}

\\-----------------------------------------------------------------------------

w = quadgen(20);
test_equal(w^2, 5);

phi=(1+w)/2;
phi*1.0

f(x) = (7/2 - 3/2*w)*x^2 + (-3 + w)*x + 1;
p = (7/2 - 3/2*w)*x^2 + (-3 + w)*x + 1
polroots(p*1.0)

subst(p,'x,phi+1)
print("f(phi+1) = ",f(phi+1));
test_equal(f(phi+1), 0);

test_equal(p/(x-(phi+1)), (7/2 - 3/2*w)*x + (-3/2 + 1/2*w));
test_equal(p/(x-(phi+1)), (7/2 - 3/2*(2*phi-1))*x + (-3/2 + 1/2*(2*phi-1)));

test_equal(p, (x-(phi+1)) * ((7/2 - 3/2*(2*phi-1))*x + (-3/2 + 1/2*(2*phi-1))));
test_equal(p, (x-(phi+1)) * ((7 - 3*(2*phi-1))*x + (-3 + (2*phi-1)))/2);
test_equal(p, (x-(phi+1)) * ((7 - 3*2*phi + 3*1)*x + (-3 + (2*phi-1)))/2);
test_equal(p, (x-(phi+1)) * ((10 - 3*2*phi)*x + (-4 + 2*phi))/2);
test_equal(2*p, (x - (phi+1)) * ((10-3*2*phi)*x + (-4+2*phi)));
test_equal(2*p/(10-3*2*phi), (x - (phi+1)) * (x + (-4+2*phi)/(10-3*2*phi)));
test_equal((7/2 + 3/2*w)*p, (x - (phi+1)) * (x + (-4+2*phi)/(10-3*2*phi)));
test_equal((7/2 + 3/2*w)*p, (x - (phi+1)) * (x + (-3/2 - 1/2*w)));
test_equal((7/2 + 3/2*w)*p, (x - (phi+1)) * (x - (phi+1)));


factor(p)
content(p)
content(p)*factorback(factor(p))
p
\\ test_equal((x-phi)^2 / (3/2 + 1/2*w), p)